using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices.ComTypes;
using System.Runtime.InteropServices;
using System.IO;

namespace PDFViewerActiveTestCS
{
    public class IStreamWrapper : IStream
    {
        private Stream m_stream;

        public IStreamWrapper(Stream stream)
        {
            if (stream == null)
                throw new ArgumentNullException("stream");
            this.m_stream = stream;
        }

        #region IStream implementation
        void IStream.Clone(out IStream ppstm)
        {
            ppstm = null;
        }
        void IStream.Commit(int grfCommitFlags)
        {
        }
        void IStream.CopyTo(IStream pstm, long cb, System.IntPtr pcbRead, System.IntPtr pcbWritten)
        {
        }
        void IStream.LockRegion(long libOffset, long cb, int dwLockType)
        {
        }
        void IStream.Read(byte[] pv, int cb, System.IntPtr pcbRead)
        {
            Marshal.WriteInt64(pcbRead, m_stream.Read(pv, 0, cb));
        }
        void IStream.Revert()
        {
        }
        void IStream.Seek(long dlibMove, int dwOrigin, System.IntPtr plibNewPosition)
        {
            Marshal.WriteInt64(plibNewPosition, m_stream.Seek(dlibMove, (SeekOrigin)dwOrigin));
        }
        void IStream.SetSize(long libNewSize)
        {
        }
        void IStream.Stat(out System.Runtime.InteropServices.ComTypes.STATSTG pstatstg, int grfStatFlag)
        {
            pstatstg = new System.Runtime.InteropServices.ComTypes.STATSTG();
        }
        void IStream.UnlockRegion(long libOffset, long cb, int dwLockType)
        {
        }
        void IStream.Write(byte[] pv, int cb, System.IntPtr pcbWritten)
        {
            try
            {
                m_stream.Write(pv, 0, cb);
                Marshal.WriteInt64(pcbWritten, cb);
            }
            catch(Exception ex)
            {
                Marshal.ThrowExceptionForHR(System.Runtime.InteropServices.Marshal.GetHRForException(ex));
            }
        }
        #endregion
    }
}
